import 'package:fcs/domain/entities/package.dart';
import 'package:fcs/helpers/theme.dart';
import 'package:fcs/pages/main/util.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_icons/flutter_icons.dart';
import 'package:intl/intl.dart';

import 'processing_info.dart';

typedef CallbackPackageSelect(Package package);

class ProcessingListRow extends StatelessWidget {
  final Package package;
  final CallbackPackageSelect callbackPackageSelect;
  final double dotSize = 15.0;
  final DateFormat dateFormat = new DateFormat("dd MMM yyyy");

  ProcessingListRow({Key key, this.package, this.callbackPackageSelect})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () {
        if (callbackPackageSelect != null) {
          callbackPackageSelect(package);
          return;
        }
        Navigator.push(
          context,
          CupertinoPageRoute(
              builder: (context) => ProcessingInfo(package: package)),
        );
      },
      child: Container(
        padding: EdgeInsets.only(left: 15, right: 15),
        child: Row(
          children: <Widget>[
            Expanded(
              child: new Padding(
                padding: const EdgeInsets.symmetric(vertical: 16.0),
                child: new Row(
                  children: <Widget>[
                    Container(
                      padding: EdgeInsets.only(left: 5, right: 10),
                      child: Icon(
                        FontAwesome.dropbox,
                        color: primaryColor,
                        size: 30,
                      ),
                    ),
                    new Expanded(
                      child: new Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                          Padding(
                            padding: const EdgeInsets.only(left: 8.0),
                            child: new Text(
                              package.id == null ? '' : package.trackingID,
                              style: new TextStyle(
                                  fontSize: 15.0, color: Colors.black),
                            ),
                          ),
                          Padding(
                            padding: const EdgeInsets.only(left: 8.0),
                            child: new Text(
                              package.market == null ? '' : package.market,
                              style: new TextStyle(
                                  fontSize: 15.0, color: Colors.black),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ],
                ),
              ),
            ),
            Column(
              children: <Widget>[
                Padding(
                  padding: const EdgeInsets.all(3.0),
                  child: getStatus(package.status),
                ),
                Padding(
                  padding: const EdgeInsets.all(0),
                  child: new Text(
                    dateFormat.format(package.currentStatusDate),
                    style: new TextStyle(fontSize: 15.0, color: Colors.grey),
                  ),
                ),
              ],
            )
          ],
        ),
      ),
    );
  }
}
